using OpenTK.Input;

namespace SanYingInput
{
	internal partial class JoystickManager
	{
		/// <summary>Represents a standard joystick, handled via openTK</summary>
		internal class StandardJoystick : Joystick
		{
			private JoystickState state;
			internal override ButtonState GetButton(int button)
			{
				return state.GetButton(button);
			}

			internal override double GetAxis(int axis)
			{
				return state.GetAxis(axis);
			}

			internal override JoystickHatState GetHat(int Hat)
			{
				return state.GetHat((JoystickHat)Hat);
			}

			internal override int AxisCount()
			{
				return OpenTK.Input.Joystick.GetCapabilities(Handle).AxisCount;
			}

			internal override int ButtonCount()
			{
				return OpenTK.Input.Joystick.GetCapabilities(Handle).ButtonCount;
			}

			internal override int HatCount()
			{
				return OpenTK.Input.Joystick.GetCapabilities(Handle).HatCount;
			}

			internal override void Poll()
			{
				state = OpenTK.Input.Joystick.GetState(Handle);
			}
		}
	}
}
