﻿namespace RouteManager2.MessageManager
{
	/// <summary>Defines the different dependencies for a message</summary>
	public enum MessageDependency
	{
		/// <summary>None</summary>
		None = 0,
		/// <summary>This message has been generated by a route speed limit</summary>
		RouteLimit = 1,
		/// <summary>This message has been generated by a section speed limit</summary>
		SectionLimit = 2,
		/// <summary>This message has been generated by a station arrival event</summary>
		StationArrival = 3,
		/// <summary>This message has been generated by a station departure event</summary>
		StationDeparture = 4,
		/// <summary>This message has been generated by a POI</summary>
		PointOfInterest = 5,
		/// <summary>This message has been generated by a plugin</summary>
		Plugin = 6,
		/// <summary>This message has been generated by changing the camera view</summary>
		CameraView = 7,
		/// <summary>This message has been generated by passing a red signal</summary>
		PassedRedSignal = 8,
		/// <summary>This message has been generated by an accessibility helper</summary>
		AccessibilityHelper = 9
	}
}
